#include "stdafx.h"
#include "STEPlugin.h"
#include "mp3infp_ExportFunc.h"

HMODULE hMp3infpDll = NULL;
LPMP3INFP_GETVER    lpmp3infp_GetVer = NULL;
LPMP3INFP_LOAD      lpmp3infp_Load = NULL;
LPMP3INFP_GETVALUE  lpmp3infp_GetValue = NULL;

bool GetValues_mp3infp(FILE_INFO *pFileMP3);
void Free_mp3infp() {
    FreeLibrary(hMp3infpDll);
}

bool Load_mp3infp() {
    if(hMp3infpDll != NULL) {
        return true;
    }
    //DLL̃[h
    hMp3infpDll = LoadLibrary(_T("mp3infp.dll"));
    if(hMp3infpDll == NULL) {
        return false;
    }
    lpmp3infp_GetVer = (LPMP3INFP_GETVER )GetProcAddress(hMp3infpDll,"mp3infp_GetVer");
#ifdef _UNICODE
    lpmp3infp_GetValue = (LPMP3INFP_GETVALUE)GetProcAddress(hMp3infpDll,"mp3infp_GetValueW");
    lpmp3infp_Load = (LPMP3INFP_LOAD)GetProcAddress(hMp3infpDll,"mp3infp_LoadW");
#else
    lpmp3infp_GetValue = (LPMP3INFP_GETVALUE)GetProcAddress(hMp3infpDll,"mp3infp_GetValue");
    lpmp3infp_Load = (LPMP3INFP_LOADA)GetProcAddress(hMp3infpDll,"mp3infp_Load");
#endif
    if (lpmp3infp_GetVer == NULL || lpmp3infp_GetValue == NULL) {
        return false;
    }
    //o[W`FbN
    DWORD dwVer = lpmp3infp_GetVer();
    if(dwVer < 0x0232) {
        return false;
    }
    return true;
}

bool GetValues_mp3infp(FILE_INFO *pFileMP3)
{
    // mp3infp.dll𗘗pĉtԂȂǂ̏擾
    if (!Load_mp3infp()) {
        return false;
    }
    if(lpmp3infp_Load(NULL,(TCHAR*)(const TCHAR *)GetFullPath(pFileMP3)) != ERROR_SUCCESS)
    {
        //printf("[hs\n");
        return false;
    }
    TCHAR* buf = NULL;
    // t
    {
        lpmp3infp_GetValue(_T("TIME"),&buf);
        UINT nDummy=0, nDummy2 = 0, nDummy3 = 0, nTime=0;
        if(buf){
            if(_tcschr(buf, _T(':')) == _tcsrchr(buf, _T(':'))) { /* Hurricane 217 */
                _stscanf_s(buf, _T("%d:%d (%dsec)"), &nDummy, &nDummy2, &nTime);
            } else {
                _stscanf_s(buf, _T("%d:%d:%d (%dsec)"), &nDummy, &nDummy2, &nDummy3, &nTime);  /* Hurricane 217 */
            }
            SetPlayTime(pFileMP3, nTime);
        }
    }
    // tH[}bg
    {
        lpmp3infp_GetValue(_T("AFMT"),&buf);
        if(buf){
           SetAudioFormat(pFileMP3, buf);
        }
    }
    return true;
}
